-- =====================================================================
-- Ada Distilled Chapter 3.9.1
-- Examples of Ada array type definitions
--
-- =====================================================================
-- 
package Ada_Distilled_3_9_1 is

   -- Enumerated types for Array Indices
   type Color is (Red, Orange, Yellow, Green, Blue, Indigo, Violet); 
   type Day is (Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday);
   
   -- One dimensional arrays
   type Float_Vector_1 is array (Integer range <>) of Float;   --  One dimensional unconstrained array
   type Float_Vector_2 is array (- 473 .. 451) of Float;       --  One dimensional constrained array
 
   type Float_Vector_3 is array (Day) of Integer;              --  One dimensional constrained array


   -- Two dimensional arrays
   type Float_Matrix is array (Integer range <>, 
                               Positive range <>) of Float;    --   Two dimensional array
   type Bool_Matrix is array  (Natural range <>,               --   First dimension of three
                               Positive range <>,              --   Second dimension of three
                               Color    range <>) of Boolean;  --   Third dimension of three
                               
   -- An array of an array
   type Mat_Vector is array (Positive range <>) 
             of Float_Matrix (1 .. 20, 5 .. 15);               --   One dimension of two dimensions

end Ada_Distilled_3_9_1;