-- =====================================================================
-- Ada Distilled Chapter 3.9.1_3
-- Examples of Ada array declarations
-- See The package, Ada_Distilled_3_9_1 for array definitions
-- =====================================================================
-- 
with Ada.Text_Io;
use  Ada;
with Ada_Distilled_3_9_1;
use  Ada_Distilled_3_9_1;
procedure Ada_Distilled_3_9_1_3 is


   V1 : Float_Vector_1 (1..6)   := (others => 0.0);                         --  Instance initialized to all 0.0
   V2 : Float_Vector_1 (1..3)   := (1 => 12.3, 3 => 6.2, 2 => 9.4);         --  Instance with initial values 
   V3 : Float_Vector_1 (0..120) := (0 => 2.6, 120 => 7.5, others  => 9.4);  --  others must appear last 
   V4 : Float_Vector_1 (12..80) := (12 => 16.3, 20 => 6.2, others  => 1.5); --  Instance with initial values 
   V5 : Float_Vector_1 (-473..-1) := (others  => Float'First);              --  Negative index range 


   -- Aggregate for two-dimensional matrix (legal for Ada 95 only)
   M1 : Float_Matrix(1..10, 1..10) :=  (1   => (1  => 0.0,
                                                others  => 1.0),    	    --  Named association for each
                                        10 => (10  => 0.0,                  --  dimension of the array and
                                                others  => 1.0),            --  others specified last
                                        others => (others => 1.0));
begin
   -- A nested for loop for a two-dimensional array
   for I in M1'range(1)	                               --  Range(1) specifies first dimension of array
     loop	                                           --  outer loop; should have been named
     for J in M1'range(2)                              --  Range(2) specifies second dimension of array
        loop	                                     --  Always name nested loops in production code
          Text_Io.Put(Float'Image(M1(I, J)) & "  " );  --  Convert component to text and print it
        end loop;	                                     --   
     Text_Io.New_Line;	                               --  Carriage return/Line feed on display
   end loop;            	                         --  

end Ada_Distilled_3_9_1_3;