-- ==========================================================================================
-- Case_Example_2.adb
--
-- See 4.2.3 in Ada Distilled for discussion of the case statements.
--  
-- Line numbers correspond to those in Ada Distilled.
-- 
-- ==========================================================================================
--
procedure Case_Example_2 is
   type Color is 
         (White,      
          Red,        
          Orange,     
          Yellow,     
          Chartreuse, 
          Green,      -- The values are the names of the colors
          Blue,       
          Indigo,     
          Violet,     
          Black,      
          Brown); -- No need for numerics

   type Value is new Integer range 0 .. 5; 
   -- The Following function Evaluates Many of The Alternatives.

   function  Decide (C : Color) return  Integer is     --  1 Simple function declaration
      Result : Integer := 0;	                         --  2 Local variable
   begin	-- Decide	                               --  3 Comment the begin statement
      case C is	                                     --  4 Start a case statement
         when Red =>	                               --  5 One of the enumerated values
            begin	                                     --  6  An unlabeled begin ... end sequence; see 4.4
               null; -- sequence-of-statements         --  7 Any sequence of Ada statements
            end;	                                     --  8 Unlabeled end statement
         when Blue =>	                               --  9 One of the enumerated values
            Label_1:	                               -- 10 Better style; use a block label
               begin                                   -- 11 Alternative:  consider calling nested subprogram
                 null; -- sequence-of-statements	 -- 12 A labeled begin requires label name at end
               end Label_1;                            -- 13 The label is required for the end statement
         when  others =>                               -- 14  Ada requires others if some choices are unmentioned
            Label_2:                                   -- 15 Yes. Still using the label; label an embedded begin block
              begin	                               -- 16 
                null;-- handled-sequence-of-statement	 -- 17 We expect a local exception handler.
              exception	                               -- 18 This is a good use of begin...end blocks
                  when Constraint_Error => null;	 -- 19 The exception handling statements
              end Label_2;	                         -- 20 The compiler will look for this
      end case;	                                     -- 21 Scope terminator is required
      return Result;	                               -- 22 Compiler will look for a return statement
   end Decide;	                                     -- 23 As usual, label the end statement
begin
   null;
end Case_Example_2; 
