-- ====================================================================================
-- Ada Distilled 
--
-- ====================================================================================
with Machinery, Rotating_Machinery;	                        --  1  The use clause simplifies this example
with Ada.Integer_Text_Io;	                              --  2  Enables the input of the array index
procedure Dynamic_Binding_Example_2 is                      --  3  Specification for the example procedure
   Data : array (1..2) of Machinery.Reference := 	      --  4
      (1 => new Machinery.Machine, 	                        --  5
       2 => new Rotating_Machinery.Rotational);	            --  6
   Index : Natural range 0..2 := 0;                         --  7  Use this to index into the array
   procedure Start(M : in out Machinery.Machine'Class) is   --  8  Procedure with classwide parameter
   begin			                                    --  9   
      Machinery.Turn_On(M);                                 -- 10  Turn_On is dynamically determined via the tag
   end Start;		                                    -- 11   
begin				                                    -- 12 
   Ada.Integer_Text_Io.Get(Index);                          -- 13 Get the index for the next statement 
   Start(M => Data(Index).all);	                        -- 14 Call the classwide procedure 
end Dynamic_Binding_Example_2;	                        -- 15 