with Ada.Calendar;                         --  1
package Messenger.Dated is               	 --  2 Package specification; requires body
   type Dated_Message is private;          --  3 Visible part of the data type; name only  
   function  Create (M : in Message) 	 --  4 function specification
      return Dated_Message;	             --  5 function always specifies a return type
private		                         --  6 private part hidden from a client of contract
   type Dated_Message is                   --  7
      record                               --  8 full definition of the publicly declared type
         Text : Message;                   --  9 string component of the type; OOP attribute 
         Date : Ada.Calendar.Time;         -- 10 how many of the 120 values are in use 
      end record;                          -- 11 scope terminator for the component
end Messenger.Dated;	                   -- 12 scope terminator for the specification