package Own_Private_Types is                            --
   type Inventory is limited private;                   -- Partial definition of limited private type
   type Inventory_Pointer is access all Inventory;      -- Declaring a pointer type in Ada
   procedure Create(Inv : in out Inventory);            -- Create an empty instance of Inventory
    -- More operations for type Inventory               --
   type Account is tagged private;                      -- Partial definition of a tagged type 
   type Account_Ref is access all Account'Class;        -- Classwide pointer type for tagged type
   procedure Create(Inv : in out Account);              -- Creates an empty Inventory record
   function Create (D : String; Id : Positive) return Account_Ref; -- returns access to new Inventory record
   -- More operations for tagged  type,  Account        --
private	                                            -- Begin private part of package
   type Inventory is                                    --
      record                                            -- A constrained record type
         Description : String (1 .. 80) := (others => ' '); -- Intialized string type record component 
         Identifier  : Positive;                            -- A positive type record component 
      end record;                                           -- End of record scope required by Ada
                                                            --
   type Account is tagged                                   --
      record                                                -- Extensible record tagged type
         Id     : String (1 .. 12);                         -- Unintialized string type component 
         Amount : Float            := 0.0;                  -- A float type record component 
      end record;                                           -- Required by language
                                                            --
end Own_Private_Types;                                      -- 
