package Own_Types is                                                  --  1 Don't do this kind of package as a rule
   type Color is (Red, Orange, Yellow, Green, Blue, Indigo, Violet);  --  2 Enumerated Type Definition                                  
   type Farenheit is digits 7 range - 473.0 .. 451.0;                 --  3 Floating point type
   type Money is delta 0.01 digits 12;                                --  4 Financial data type for accounting
   type Quarndex is range - 3_000 .. 10_000;                          --  5 Integer type; note underbar notation
   type Vector is array (1 .. 100) of Farenheit;                      --  6 Constrained array type
   type Color_Mix is array (Color) of Boolean;                        --  7 Constrained by Color set
   type Inventory is                                                  --  8
      record                                                          --  9 A constrained record type
         Description : String (1 .. 80) := (others => ' ');           -- 10 Intialized string type record component 
         Identifier  : Positive;                                      -- 11 A positive type record component 
      end record;                                                     -- 12End of record scope required by Ada
   type Inventory_Pointer is access all Inventory;                    -- 13 Declaring a pointer type in Ada
   type Qdata is array (Positive range <>) of Quarndex;               -- 14 Unconstrained array type
   type Account is tagged                                             -- 15
      record                                                          -- 16 See next example: 1.5.3.3
         Id     : String (1 .. 20);                                   -- 17 Unintialized string type component 
         Amount : Money            := 0.0;                            -- 18 See line 4 of this package 
      end record;                                                     -- 19 Required by language
   type Account_Ref is access all Account'Class;                      -- 20 Classwide pointer type for tagged type
end Own_Types;                                                        -- 21                                             
