with Ada.Text_Io, Ada.Integer_Text_Io, Ada.Float_Text_Io;	             --  1   
use  Ada;		                                                       --  2
procedure Scalar_To_String_Demonstration is	                         --  3
   type Spectrum is (Red, Orange, Yellow, Green, Blue, Indigo, Violet);  --  4
   type Unsigned is mod 2**8;                                            --  5
   Num   : Integer  := 451;	                                           --  6
   Fnum  : Float    := 360.0;	                                           --  7
   Color : Spectrum := Blue;	                                           --  8
   Mnum  : Unsigned := 42;	                                           --  9
   Text  : String(1..10);	                                           -- 10
   package Sio is new Text_Io.Enumeration_Io(Enum => Spectrum);	       -- 11
   package Mio is new Text_Io.Modular_Io    (Num  => Unsigned);	       -- 12
   package Iio is new Text_Io.Integer_Io        (Num  => Integer);	 -- 13
   package Fio is new Text_Io.Float_Io          (Num  => Float);	       -- 14
begin			                                                       -- 15
   -- Example 1; using the image attribute	                         -- 16
   Text_Io.Put_Line(" Example 1; Using 'Image Attribute ");	             -- 17
   Text_Io.Put_Line(Spectrum'Image(Color));	                         -- 18
   Text_Io.Put_Line(Unsigned'Image(Mnum));	                         -- 19
   Text_Io.Put_Line(Integer'Image(Num));	                               -- 20
   Text_Io.Put_Line(Float'Image(Fnum));	                               -- 21
   Text_Io.New_Line;	                                                 -- 22
   -- Example 2; using the procedures of pre-instantiated packages	 -- 23
   Text_Io.Put_Line(" Example 2; using pre-instantiated packages " );    -- 24
   Integer_Text_Io.Put(Num); Text_Io.New_Line;	                         -- 25
   Float_Text_Io.Put  (Fnum, Fore => 3, Aft => 3, Exp => 0);  	       -- 26
   Text_Io.New_Line(2);	                                                 -- 27
   -- Example 3; using your own instantiated packages	                   -- 28
   Text_Io.Put_Line(" Example 3; Using own instantiations ");	       -- 29
   Sio.Put(Color);   Text_Io.New_Line;	                               -- 30
   Mio.Put(Mnum);    Text_Io.New_Line;	                               -- 31
   Iio.Put(Num);     Text_Io.New_Line;	                               -- 32
   Fio.Put(Fnum, Fore => 3, Aft => 3, Exp => 0);    	                   -- 33
   Text_Io.New_Line(2);	                                                 -- 34
   -- Example 4; convert to text and then print	                         -- 35
   Text_Io.Put_Line("Example 4; Convert to text, then print ");	       -- 36
   Sio.Put(To => Text, Item => Color);	                               -- 37
   Text_Io.Put_Line(Text);	                                           -- 38
   Mio.Put(To => Text, Item => Mnum);	                               -- 39
   Text_Io.Put_Line(Text);	                                           -- 40
   Iio.Put(To => Text, Item => Num);	                               -- 41
   Text_Io.Put_Line(Text);	                                           -- 42
   Fio.Put(To => Text, Item => Fnum, Aft => 3, Exp => 0);	             -- 43
   Text_Io.Put_Line(Text);	                                           -- 44
   Text_Io.New_Line;	                                                 -- 45
   Text_Io.Put_Line("End of Image_Demonstration ");	                   -- 46
end Scalar_To_String_Demonstration;	                                     -- 47