with Defined_Types;
with Real_Functions;
with Generic_Utilities;
with Ada.Text_IO;  use Ada;
procedure Test_Math_Functions is

   subtype Degree  is Defined_Types.Real range 1.0..360.0;
   subtype Radian  is Defined_Types.Real range 0.0..6.28;
   package RIO is new Text_IO.Float_IO(Num => Defined_Types.Real);   
   function To_Degrees is new Generic_Utilities.To_Degrees(Degree => Degree, Radian => Radian);
   function To_Radians is new Generic_Utilities.To_Radians(Degree => Degree, Radian => Radian);
   R1, R2, R3, R4 : Radian := 0.0;
   D1 : Degree := 90.0;
   D2 : Degree := 45.0;
   procedure Display(Prompt : String; Data : Defined_Types.Real) is
   begin
       Text_IO.Put(Prompt & " ");
       RIO.Put(Item => Data, Fore => 4, Aft => 5, Exp => 0);
       Text_IO.New_Line;
   end Display;
   
begin
   R1 := To_Radians(D1);
   Display("R1 = ", R1);
   R2 := Real_Functions.Sin(X => R1);
   Display("Sin(R1) = ", R2);
   R2 := Real_Functions.Sin(X => R1, Cycle => D2);
   Display("Sin(R1) with Cycle = ", R2);
   R2 := Real_Functions.ArcSinh(X => R1);
   Display("ArcSinh(R1) = ", R2);
   R3 := Real_Functions.ArcCot(X => R1, Cycle => 40.0);
   Display("Arcot(R1) with Cycle = ", R3);
   R4 := Real_Functions.Cos(X => R1, Cycle => D2);
   Display("Cos(R1) with Cycle = ", R4);
   R1 := To_Radians(D2);
   R3 := Real_Functions.Tan(X => R1);
   Display("Tan(R1) = ", R3);
   D2 := To_Degrees(R2);
   Display("To_Degrees(R1) = ", D2);
end Test_Math_Functions;