with Some_Types;	                                                  --  1 Context clause from prior example
with Ada.Unchecked_Conversion;                                      --  2 Context clause for generic  Ada library function 
use  Ada;	                                                        --  3 Makes package Ada directly visible
procedure Test_Some_Types is 	                                      --  4 Name for unparameterized procedure
   Ch1,  Ch2, Ch3  : Some_Types.Channel := 42;                      --  5 Initialize declared variables
   Sig1, Sig2      : Some_Types.Signal := 27;                       --  6 Note dot notation in declared variables
   Level_1, Level_2  : Some_Types.Level        := 360.0;            --  7 Declared variables with dot notation
   Tiny                     : Some_Types.Small_Signal := 4;	        --  8 
   Color_1, Color_2 : Some_Types.Color        := Some_Types.Red;    --  9 Enumerated type declarations
   Light_1, Light_2 : Some_Types.Light        := Some_Types.Red;	  -- 10  
   Tr1, Tr2, Tr3       : Some_Types.Traffic      := Some_Types.Red; -- 11 
   use type Some_Types.Channel;                                     -- 12 Makes operators visible for this type
   function Convert is new Unchecked_Conversion                     -- 13 Enable asssignment between variables of
      (Source => Some_Types.Light, Target => Some_Types.Traffic);   -- 14 differing types without compile-time checking
begin		                                                        -- 15 
   Ch3 := Ch1 + Ch2;                     	                          -- 16 use type makes + operator visible
   Level_1 := Some_Types.Level(Ch1);                                -- 17 Type conversion legal between numeric types
   Tiny := Sig1;                         	                          -- 18 This will compile because of subtype 
   Tr3 := Some_Types.Traffic(Color_1);                              -- 19 OK. Traffic is  derived from Color 
   Tr1 := Some_Types.Traffic'Succ(Tr2);     	                    -- 21 This statement is OK
   Tr2 := Convert(Light_1);              	                          -- 22 Assign dissimilar data without checking
   Light_2 := Convert(TR3);              	                          -- 23 Fails to compile; convert is only one direction
end Test_Some_Types;	                                            -- 24